//---------------------------------------------------------------------------
// Version: 1.0.0
// Author: Moochos
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "Moa_AutoPointer.h"
#include "Moa_File.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
namespace Moa_file {
//---------------------------------------------------------------------------
const bool TPath::ValidPathCharTable[256] = {
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	1, 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 1, 1, 1, 1, 0,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
};
	// 0: [0-31] [<] [>] ["] [/] [|] [?] [*]
	// 1: Not 0
const bool TPath::ValidNameCharTable[256] = {
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	1, 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 1, 1, 1, 1, 0,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 1, 0, 1, 0, 0,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
};
	// 0: [0-31] [<] [>] [:] ["] [/] [\] [|] [?] [*]
	// 1: Not 0
const bool TPath::WildcardCharTable[256] = {
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
};
	// 0: Not 1
	// 1: [?] [*]
const char TPath::DriveSep = ':';
const char TPath::DirectorySep = '\\';
const char TPath::ExtensionSep = '.';
//---------------------------------------------------------------------------
AnsiString __fastcall TPath::GetPath() const
{
	return FPath;
}
//---------------------------------------------------------------------------
void __fastcall TPath::SetPath(const AnsiString& APath)
{
	FPath = APath;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TPath::GetDrivePart() const
{
	return TPath(Root).EndWithout(DirectorySep);
}
//---------------------------------------------------------------------------
void __fastcall TPath::SetDrivePart(const AnsiString& ADrivePart)
{
	Root = TPath(ADrivePart).EndWith(DirectorySep);
}
//---------------------------------------------------------------------------
AnsiString __fastcall TPath::GetDrive() const
{
	return TPath(DrivePart).EndWithout(DriveSep);
}
//---------------------------------------------------------------------------
void __fastcall TPath::SetDrive(const AnsiString& ADrive)
{
	DrivePart = TPath(ADrive).EndWith(DriveSep);
}
//---------------------------------------------------------------------------
AnsiString __fastcall TPath::GetRoot() const
{
	return Sysutils::ExtractFileDrive(Path);
}
//---------------------------------------------------------------------------
void __fastcall TPath::SetRoot(const AnsiString& ARoot)
{
	AnsiString LRoot = Root;
	if(LRoot.Length() == 0) {
		throw EFileError("The program cannot set the root of the path.");
	}
	Path = ARoot + AnsiString(Path).Delete(1, LRoot.Length());
}
//---------------------------------------------------------------------------
AnsiString __fastcall TPath::GetDirectoryPart() const
{
	return Sysutils::ExtractFilePath(Path);
}
//---------------------------------------------------------------------------
void __fastcall TPath::SetDirectoryPart(const AnsiString& ADirectoryPart)
{
	Path = ADirectoryPart + AnsiString(Path).Delete(1, DirectoryPart.Length());
}
//---------------------------------------------------------------------------
AnsiString __fastcall TPath::GetDirectory() const
{
	return Sysutils::ExtractFileDir(Path);
}
//---------------------------------------------------------------------------
void __fastcall TPath::SetDirectory(const AnsiString& ADirectory)
{
	Path = ADirectory + AnsiString(Path).Delete(1, Directory.Length());
}
//---------------------------------------------------------------------------
AnsiString __fastcall TPath::GetName() const
{
	return Sysutils::ExtractFileName(Path);
}
//---------------------------------------------------------------------------
void __fastcall TPath::SetName(const AnsiString& AName)
{
	Path = AnsiString(Path).SetLength(Path.Length() - Name.Length()) + AName;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TPath::GetBaseName() const
{
	return Sysutils::ChangeFileExt(Name, AnsiString());
}
//---------------------------------------------------------------------------
void __fastcall TPath::SetBaseName(const AnsiString& ABaseName)
{
	Name = ABaseName + ExtensionPart;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TPath::GetExtensionPart() const
{
	return Sysutils::ExtractFileExt(Path);
}
//---------------------------------------------------------------------------
void __fastcall TPath::SetExtensionPart(const AnsiString& AExtensionPart)
{
	Path = Sysutils::ChangeFileExt(Path, AExtensionPart);
}
//---------------------------------------------------------------------------
int __fastcall TPath::GetLength() const
{
	return Path.Length();
}
//---------------------------------------------------------------------------
AnsiString __fastcall TPath::GetExtension() const
{
	return TPath(ExtensionPart).StartWithout(ExtensionSep);
}
//---------------------------------------------------------------------------
void __fastcall TPath::SetExtension(const AnsiString& AExtension)
{
	if(AExtension.Length() > 0) {
		ExtensionPart = TPath(AExtension).StartWith(ExtensionSep);
	}
	else {
		ExtensionPart = AnsiString();
	}
}
//---------------------------------------------------------------------------
void __fastcall TPath::SetLength(int ALength)
{
	Path = AnsiString(Path).SetLength(ALength);
}
//---------------------------------------------------------------------------
int __fastcall TPath::Compare(const AnsiString& APath1, const AnsiString& APath2)
{
	return Sysutils::AnsiCompareFileName(APath1, APath2);
}
//---------------------------------------------------------------------------
TPath __fastcall TPath::Compose(const AnsiString& ADirectory, const AnsiString& AName)
{
	if(ADirectory.Length() == 0) {
		return AName;
	}
	else {
		return TPath(ADirectory).EndWith(DirectorySep) + AName;
	}
}
//---------------------------------------------------------------------------
TPath __fastcall TPath::ComposeName(const AnsiString& ABaseName, const AnsiString& AExtension)
{
	if(AExtension.Length() == 0) {
		return ABaseName;
	}
	else {
		return TPath(ABaseName).PushExtension(AExtension);
	}
}
//---------------------------------------------------------------------------
bool __fastcall TPath::IsValidPathChar(char AChar)
{
	return ValidPathCharTable[static_cast<unsigned char>(AChar)];
}
//---------------------------------------------------------------------------
bool __fastcall TPath::IsValidNameChar(char AChar)
{
	return ValidNameCharTable[static_cast<unsigned char>(AChar)];
}
//---------------------------------------------------------------------------
bool __fastcall TPath::IsWildcardChar(char AChar)
{
	return WildcardCharTable[static_cast<unsigned char>(AChar)];
}
//---------------------------------------------------------------------------
__fastcall TPath::TPath() :
	FPath()
{
	// Do nothing
}
//---------------------------------------------------------------------------
__fastcall TPath::TPath(const TPath& AOther) :
	FPath(AOther.Path)
{
	// Do nothing
}
//---------------------------------------------------------------------------
__fastcall TPath::TPath(const AnsiString& APath) :
	FPath(APath)
{
	// Do nothing
}
//---------------------------------------------------------------------------
__fastcall TPath::~TPath()
{
	// Do nothing
}
//---------------------------------------------------------------------------
TPath& __fastcall TPath::operator =(const TPath& AOther)
{
	if(&AOther == this) {
		return *this;
	}
	Path = AOther.Path;
	return *this;
}
//---------------------------------------------------------------------------
TPath __fastcall TPath::operator +(const TPath& AOther) const
{
	return TPath(Path + AOther.Path);
}
//---------------------------------------------------------------------------
TPath& __fastcall TPath::operator +=(const TPath& AOther)
{
	Path = *this + AOther;
	return *this;
}
//---------------------------------------------------------------------------
bool __fastcall TPath::operator ==(const TPath& AOther) const
{
	return Compare(Path, AOther.Path) == 0;
}
//---------------------------------------------------------------------------
bool __fastcall TPath::operator !=(const TPath& AOther) const
{
	return !(*this == AOther);
}
//---------------------------------------------------------------------------
bool __fastcall TPath::operator <(const TPath& AOther) const
{
	return Compare(Path, AOther.Path) < 0;
}
//---------------------------------------------------------------------------
bool __fastcall TPath::operator <=(const TPath& AOther) const
{
	int LDifference = Compare(Path, AOther.Path);
	return LDifference < 0 || LDifference == 0;
}
//---------------------------------------------------------------------------
bool __fastcall TPath::operator >(const TPath& AOther) const
{
	return Compare(Path, AOther.Path) > 0;
}
//---------------------------------------------------------------------------
bool __fastcall TPath::operator >=(const TPath& AOther) const
{
	int LDifference = Compare(Path, AOther.Path);
	return LDifference > 0 || LDifference == 0;
}
//---------------------------------------------------------------------------
__fastcall TPath::operator AnsiString() const
{
	return Path;
}
//---------------------------------------------------------------------------
TPath& __fastcall TPath::Expand()
{
	Path = Sysutils::ExpandFileName(Path);
	return *this;
}
//---------------------------------------------------------------------------
TPath& __fastcall TPath::ExpandUnc()
{
	Path = Sysutils::ExpandUNCFileName(Path);
	return *this;
}
//---------------------------------------------------------------------------
TPath& __fastcall TPath::StartWith(char AChar)
{
	if(!StartsWith(AChar)) {
		Path = AnsiString(AChar) + Path;
	}
	return *this;
}
//---------------------------------------------------------------------------
TPath& __fastcall TPath::StartWithout(char AChar)
{
	if(StartsWith(AChar)) {
		Path = AnsiString(Path).Delete(1, 1);
	}
	return *this;
}
//---------------------------------------------------------------------------
TPath& __fastcall TPath::EndWith(char AChar)
{
	if(!EndsWith(AChar)) {
		Path = Path + AnsiString(AChar);
	}
	return *this;
}
//---------------------------------------------------------------------------
TPath& __fastcall TPath::EndWithout(char AChar)
{
	if(EndsWith(AChar)) {
		Path = AnsiString(Path).Delete(Path.Length(), 1);
	}
	return *this;
}
//---------------------------------------------------------------------------
void __fastcall TPath::Process(TStrings* AComponents) const
{
	TAutoPointer<TStringList> LComponents = new TStringList();
	TPath LPath = *this;
	while(LPath.Length > 0) {
		LComponents->Add(LPath.Pop());
	}
	AComponents->Assign(LComponents);
}
//---------------------------------------------------------------------------
TPath& __fastcall TPath::Push(const AnsiString& AComponent)
{
	*this =
		TPath(*this).EndWith(DirectorySep) +
		TPath(AComponent).StartWithout(DirectorySep);
	return *this;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TPath::Pop()
{
	TPath LComponent = Peek();
	TPath LPath = *this;
	LPath.Length = LPath.Length - LComponent.Length;
	LPath.EndWithout(DirectorySep);
	*this = LPath;
	return LComponent;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TPath::Peek() const
{
	return Name;
}
//---------------------------------------------------------------------------
TPath& __fastcall TPath::PushExtension(const AnsiString& AExtension)
{
	if(AExtension.Length() > 0) {
		Path = Path + ExtensionSep + AExtension;
	}
	return *this;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TPath::PopExtension()
{
	AnsiString LExtension = Peek();
	Extension = AnsiString();
	return LExtension;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TPath::PeekExtension() const
{
	return Extension;
}
//---------------------------------------------------------------------------
TPath& __fastcall TPath::MakeAbsolute(const AnsiString& ADirectory)
{
	*this =
		TPath(ADirectory).EndWith(DirectorySep) +
		TPath(*this).MakeRelative(ADirectory).StartWithout(DirectorySep);
	return *this;
}
//---------------------------------------------------------------------------
TPath& __fastcall TPath::MakeRelative(const AnsiString& ADirectory)
{
	Path = Sysutils::ExtractRelativePath(Sysutils::IncludeTrailingPathDelimiter(ADirectory), Path);
	return *this;
}
//---------------------------------------------------------------------------
TPath& __fastcall TPath::MakeUpperCase()
{
	Path = Sysutils::AnsiUpperCaseFileName(Path);
	return *this;
}
//---------------------------------------------------------------------------
TPath& __fastcall TPath::MakeLowerCase()
{
	Path = Sysutils::AnsiLowerCaseFileName(Path);
	return *this;
}
//---------------------------------------------------------------------------
bool __fastcall TPath::IsAbsolute() const
{
	return Root.Length() > 0;
}
//---------------------------------------------------------------------------
bool __fastcall TPath::IsRelative() const
{
	return !IsAbsolute();
}
//---------------------------------------------------------------------------
bool __fastcall TPath::IsRoot() const
{
	return Compare(Path, Root) == 0;
}
//---------------------------------------------------------------------------
bool __fastcall TPath::IsMask() const
{
	AnsiString LPath = Path;
	const char* LPos = LPath.c_str();
	while(*LPos != '\0') {
		if(!IsWildcardChar(*LPos)) {
			return false;
		}
		LPos = ::CharNext(LPos);
	}
	return true;
}
//---------------------------------------------------------------------------
bool __fastcall TPath::IsDot() const
{
	return ::lstrcmpi(Path.c_str(), ".") == 0;
}
//---------------------------------------------------------------------------
bool __fastcall TPath::IsDotDot() const
{
	return ::lstrcmpi(Path.c_str(), "..") == 0;
}
//---------------------------------------------------------------------------
bool __fastcall TPath::IsValidPath() const
{
	AnsiString LPath = Path;
	const char* LPos = LPath.c_str();
	while(*LPos != '\0') {
		if(!IsValidPathChar(*LPos)) {
			return false;
		}
		LPos = ::CharNext(LPos);
	}
	return true;
}
//---------------------------------------------------------------------------
bool __fastcall TPath::IsValidName() const
{
	AnsiString LPath = Path;
	const char* LPos = LPath.c_str();
	while(*LPos != '\0') {
		if(!IsValidNameChar(*LPos)) {
			return false;
		}
		LPos = ::CharNext(LPos);
	}
	return true;
}
//---------------------------------------------------------------------------
bool __fastcall TPath::StartsWith(char AChar) const
{
	return Path.Length() > 0 && *Path.c_str() == AChar;
}
//---------------------------------------------------------------------------
bool __fastcall TPath::EndsWith(char AChar) const
{
	return Path.Length() > 0 && Path.ByteType(Path.Length()) == mbSingleByte && *(Path.c_str() + Path.Length() - 1) == AChar;
}
//---------------------------------------------------------------------------
int __fastcall TPath::Compare(const TPath& AOther) const
{
	return Compare(Path, AOther.Path);
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
const char* TDeviceNames::Table[] = {
	"CON", "PRN", "AUX", "NUL",
	"COM1", "COM2", "COM3", "COM4", "COM5", "COM6", "COM7", "COM8", "COM9",
	"LPT1", "LPT2", "LPT3", "LPT4", "LPT5", "LPT6", "LPT7", "LPT8", "LPT9",
};
const int TDeviceNames::TableSize = sizeof(Table) / sizeof(char*);
//---------------------------------------------------------------------------
AnsiString __fastcall TDeviceNames::GetName(int AIndex) const
{
	if(AIndex < 0 || AIndex >= Count) {
		throw EFileError("Invalid index for a device name.");
	}
	return Table[AIndex];
}
//---------------------------------------------------------------------------
int __fastcall TDeviceNames::GetCount() const
{
	return TableSize;
}
//---------------------------------------------------------------------------
__fastcall TDeviceNames::TDeviceNames()
{
	// Do nothing
}
//---------------------------------------------------------------------------
__fastcall TDeviceNames::~TDeviceNames()
{
	// Do nothing
}
//---------------------------------------------------------------------------
int __fastcall TDeviceNames::Find(const AnsiString& AName)
{
	for(int LI = 0; LI < Count; ++LI) {
		if(Sysutils::AnsiCompareFileName(AName, Names[LI]) == 0) {
			return LI;
		}
	}
	return -1;
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
AnsiString __fastcall TFile::GetLongPath() const
{
	AnsiString LLongPath;
	if(!TryGetLongPath(LLongPath)) {
		throw EFileError("The program could not get the long path of the file.");
	}
	return LLongPath;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TFile::GetLongName() const
{
	AnsiString LLongName;
	if(!TryGetLongName(LLongName)) {
		throw EFileError("The program could not get the long name of the file.");
	}
	return LLongName;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TFile::GetShortPath() const
{
	AnsiString LShortPath;
	if(!TryGetShortPath(LShortPath)) {
		throw EFileError("The program could not get the short path of the file.");
	}
	return LShortPath;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TFile::GetShortName() const
{
	AnsiString LShortName;
	if(!TryGetShortName(LShortName)) {
		throw EFileError("The program could not get the short name of the file.");
	}
	return LShortName;
}
//---------------------------------------------------------------------------
DWORDLONG __fastcall TFile::GetSize() const
{
	DWORDLONG LSize;
	if(!TryGetSize(LSize)) {
		throw EFileError("The program could not get the size of the file.");
	}
	return LSize;
}
//---------------------------------------------------------------------------
DWORD __fastcall TFile::GetAttributes() const
{
	DWORD LAttributes;
	if(!TryGetAttributes(LAttributes)) {
		throw EFileError("The program could not get the attributes of the file.");
	}
	return LAttributes;
}
//---------------------------------------------------------------------------
void __fastcall TFile::SetAttributes(DWORD AAttributes)
{
	if(!TrySetAttributes(AAttributes)) {
		throw EFileError("The program could not set the attributes of the file.");
	}
}
//---------------------------------------------------------------------------
FILETIME __fastcall TFile::GetCreationTime() const
{
	FILETIME LCreationTime;
	if(!TryGetTimes(&LCreationTime, NULL, NULL)) {
		throw EFileError("The program could not get the creation time of the file.");
	}
	return LCreationTime;
}
//---------------------------------------------------------------------------
void __fastcall TFile::SetCreationTime(const FILETIME& ACreationTime)
{
	if(!TrySetTimes(&ACreationTime, NULL, NULL)) {
		throw EFileError("The program could not set the creation time of the file.");
	}
}
//---------------------------------------------------------------------------
FILETIME __fastcall TFile::GetLastWriteTime() const
{
	FILETIME LLastWriteTime;
	if(!TryGetTimes(&LLastWriteTime, NULL, NULL)) {
		throw EFileError("The program could not get the last write time of the file.");
	}
	return LLastWriteTime;
}
//---------------------------------------------------------------------------
void __fastcall TFile::SetLastWriteTime(const FILETIME& ALastWriteTime)
{
	if(!TrySetTimes(&ALastWriteTime, NULL, NULL)) {
		throw EFileError("The program could not set the last write time of the file.");
	}
}
//---------------------------------------------------------------------------
FILETIME __fastcall TFile::GetLastAccessTime() const
{
	FILETIME LLastAccessTime;
	if(!TryGetTimes(&LLastAccessTime, NULL, NULL)) {
		throw EFileError("The program could not get the last access time of the file.");
	}
	return LLastAccessTime;
}
//---------------------------------------------------------------------------
void __fastcall TFile::SetLastAccessTime(const FILETIME& ALastAccessTime)
{
	if(!TrySetTimes(&ALastAccessTime, NULL, NULL)) {
		throw EFileError("The program could not set the last access time of the file.");
	}
}
//---------------------------------------------------------------------------
WIN32_FIND_DATA __fastcall TFile::GetData() const
{
	WIN32_FIND_DATA LData;
	if(!TryGetData(LData)) {
		throw EFileError("The program could not get the data of the file.");
	}
	return LData;
}
//---------------------------------------------------------------------------
__fastcall TFile::TFile() :
	FPath()
{
	// Do nothing
}
//---------------------------------------------------------------------------
__fastcall TFile::TFile(const TFile& AOther) :
	FPath(AOther.Path)
{
	// Do nothing
}
//---------------------------------------------------------------------------
__fastcall TFile::TFile(const AnsiString& APath) :
	FPath(APath)
{
	// Do nothing
}
//---------------------------------------------------------------------------
__fastcall TFile::~TFile()
{
	// Do nothing
}
//---------------------------------------------------------------------------
bool __fastcall TFile::TryGetLongPath(AnsiString& ALongPath) const
{
	if(Path.Length() >= MAX_PATH) {
		return false;
	}
	if(!TPath(Path).IsValidPath()) { // Trap the mask
		return false;
	}
	DWORD LBufferSize = ::GetLongPathName(Path.c_str(), NULL, 0);
	if(LBufferSize == 0) {
		return false;
	}
	TAutoArray<TCHAR> LBuffer = new TCHAR[LBufferSize];
	DWORD LStringLength = ::GetLongPathName(Path.c_str(), LBuffer, LBufferSize);
	if(LStringLength == 0 || LStringLength >= LBufferSize) {
		return false;
	}
	ALongPath= AnsiString(LBuffer, LStringLength);
	return true;
}
//---------------------------------------------------------------------------
bool __fastcall TFile::TryGetLongName(AnsiString& ALongName) const
{
	WIN32_FIND_DATA LData;
	if(!TryGetData(LData)) {
		return false;
	}
	ALongName = LData.cFileName;
	return true;
}
//---------------------------------------------------------------------------
bool __fastcall TFile::TryGetShortPath(AnsiString& AShortPath) const
{
	if(!TPath(Path).IsValidPath()) { // Trap the mask
		return false;
	}
	DWORD LBufferSize = ::GetShortPathName(Path.c_str(), NULL, 0);
	if(LBufferSize == 0) {
		return false;
	}
	TAutoArray<TCHAR> LBuffer = new TCHAR[LBufferSize];
	DWORD LStringLength = ::GetShortPathName(Path.c_str(), LBuffer, LBufferSize);
	if(LStringLength == 0 || LStringLength >= LBufferSize) {
		return false;
	}
	AShortPath = AnsiString(LBuffer, LStringLength);
	return true;
}
//---------------------------------------------------------------------------
bool __fastcall TFile::TryGetShortName(AnsiString& AShortName) const
{
	WIN32_FIND_DATA LData;
	if(!TryGetData(LData)) {
		return false;
	}
	AShortName = LData.cAlternateFileName;
	return true;
}
//---------------------------------------------------------------------------
bool __fastcall TFile::TryGetSize(DWORDLONG& ASize) const
{
	WIN32_FIND_DATA LData;
	if(!TryGetData(LData)) {
		return false;
	}
	ULARGE_INTEGER LSize;
	LSize.LowPart = LData.nFileSizeLow;
	LSize.HighPart = LData.nFileSizeHigh;
	ASize = LSize.QuadPart;
	return true;
}
//---------------------------------------------------------------------------
bool __fastcall TFile::TryGetAttributes(DWORD& AAttributes) const
{
	AAttributes = ::GetFileAttributes(Path.c_str());
	return AAttributes != 0xFFFFFFFF;
}
//---------------------------------------------------------------------------
bool __fastcall TFile::TrySetAttributes(DWORD AAttributes)
{
	return ::SetFileAttributes(Path.c_str(), AAttributes);
}
//---------------------------------------------------------------------------
void __fastcall TFile::GetTimes(FILETIME* ACrTime, FILETIME* ALaTime, FILETIME* ALwTime) const
{
	if(!TryGetTimes(ACrTime, ALaTime, ALwTime)) {
		throw EFileError("The program could not get the times of the file.");
	}
}
//---------------------------------------------------------------------------
bool __fastcall TFile::TryGetTimes(FILETIME* ACrTime, FILETIME* ALaTime, FILETIME* ALwTime) const
{
	WIN32_FIND_DATA LData = {0};
	if(!TryGetData(LData)) {
		return false;
	}
	if(ACrTime != NULL) {
		*ACrTime = LData.ftCreationTime;
	}
	if(ALwTime != NULL) {
		*ALwTime = LData.ftLastWriteTime;
	}
	if(ALaTime != NULL) {
		*ALaTime = LData.ftLastAccessTime;
	}
	return true;
}
//---------------------------------------------------------------------------
void __fastcall TFile::SetTimes(const FILETIME* ACrTime, const FILETIME* ALaTime, const FILETIME* ALwTime)
{
	if(!TrySetTimes(ACrTime, ALaTime, ALwTime)) {
		throw EFileError("The program could not set the times of the file.");
	}
}
//---------------------------------------------------------------------------
bool __fastcall TFile::TrySetTimes(const FILETIME* ACrTime, const FILETIME* ALaTime, const FILETIME* ALwTime)
{//@@
	HANDLE LHandle = ::CreateFile(
		Path.c_str(),
		GENERIC_WRITE,
		0,
		NULL,
		OPEN_EXISTING,
		TFiles().DirectoryExists(Path) ?
			FILE_ATTRIBUTE_NORMAL | FILE_FLAG_BACKUP_SEMANTICS :
			FILE_ATTRIBUTE_NORMAL,
		NULL);
	if(LHandle == INVALID_HANDLE_VALUE) {
		return false;
	}
	try {
		if(!::SetFileTime(LHandle, ACrTime, ALaTime, ALwTime)) {
			return false;
		}
	}
	__finally {
		::CloseHandle(LHandle);
	}
	return true;
}
//---------------------------------------------------------------------------
bool __fastcall TFile::TryGetCreationTime(FILETIME& ACreationTime) const
{
	return TryGetTimes(&ACreationTime, NULL, NULL);
}
//---------------------------------------------------------------------------
bool __fastcall TFile::TrySetCreationTime(const FILETIME& ACreationTime)
{
	return TrySetTimes(&ACreationTime, NULL, NULL);
}
//---------------------------------------------------------------------------
bool __fastcall TFile::TryGetLastWriteTime(FILETIME& ALastWriteTime) const
{
	return TryGetTimes(NULL, &ALastWriteTime, NULL);
}
//---------------------------------------------------------------------------
bool __fastcall TFile::TrySetLastWriteTime(const FILETIME& ALastWriteTime)
{
	return TrySetTimes(NULL, &ALastWriteTime, NULL);
}
//---------------------------------------------------------------------------
bool __fastcall TFile::TryGetLastAccessTime(FILETIME& ALastAccessTime) const
{
	return TryGetTimes(NULL, NULL, &ALastAccessTime);
}
//---------------------------------------------------------------------------
bool __fastcall TFile::TrySetLastAccessTime(const FILETIME& ALastAccessTime)
{
	return TrySetTimes(NULL, NULL, &ALastAccessTime);
}
//---------------------------------------------------------------------------
bool __fastcall TFile::TryGetData(WIN32_FIND_DATA& AData) const
{
	if(!TPath(Path).IsValidPath()) { // Trap the mask
		return false;
	}
	HANDLE LHandle = ::FindFirstFile(Path.c_str(), &AData);
	if(LHandle == INVALID_HANDLE_VALUE) {
		return false;
	}
	::FindClose(LHandle);
	return true;
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
AnsiString __fastcall TFiles::GetCurrentDirectory() const
{
	return Sysutils::GetCurrentDir();
}
//---------------------------------------------------------------------------
void __fastcall TFiles::SetCurrentDirectory(const AnsiString& ACurrentDirectory)
{
	Sysutils::SetCurrentDir(ACurrentDirectory);
}
//---------------------------------------------------------------------------
__fastcall TFiles::TFiles()
{
	// Do nothing
}
//---------------------------------------------------------------------------
__fastcall TFiles::~TFiles()
{
	// Do nothing
}
//---------------------------------------------------------------------------
AnsiString __fastcall TFiles::CreateTemporaryFile(const AnsiString& ADirectory, const AnsiString& APrefix)
{
	if(APrefix.Length() > 3) {
		throw EFileError("The prefix is too long.");
	}
	int LBufferSize = MAX_PATH;
	TAutoArray<TCHAR> LBuffer = new TCHAR[LBufferSize];
	::ZeroMemory(LBuffer, sizeof(TCHAR) * LBufferSize);
	if(::GetTempFileName(ADirectory.c_str(), APrefix.c_str(), 0, LBuffer) == 0) {
		throw EFileError("The program could not create the temporary file.");
	}
	return LBuffer.Pointer;
}
//---------------------------------------------------------------------------
void __fastcall TFiles::Move(const AnsiString& ASrcPath, const AnsiString& ADstPath)
{
	if(!TryMove(ASrcPath, ADstPath)) {
		throw EFileError("The program could not move the file.");
	}
}
//---------------------------------------------------------------------------
bool __fastcall TFiles::TryMove(const AnsiString& ASrcPath, const AnsiString& ADstPath)
{
	return ::MoveFile(ASrcPath.c_str(), ADstPath.c_str());
}
//---------------------------------------------------------------------------
void __fastcall TFiles::Copy(const AnsiString& ASrcPath, const AnsiString& ADstPath, bool AOverwirte)
{
	if(!TryCopy(ASrcPath, ADstPath, AOverwirte)) {
		throw EFileError("The program could not copy the file.");
	}
}
//---------------------------------------------------------------------------
bool __fastcall TFiles::TryCopy(const AnsiString& ASrcPath, const AnsiString& ADstPath, bool AOverwirte)
{
	return ::CopyFile(ASrcPath.c_str(), ADstPath.c_str(), !AOverwirte);
}
//---------------------------------------------------------------------------
void __fastcall TFiles::Delete(const AnsiString& APath)
{
	if(!TryDelete(APath)) {
		throw EFileError("The program could not delete the file.");
	}
}
//---------------------------------------------------------------------------
bool __fastcall TFiles::TryDelete(const AnsiString& APath)
{
	return ::DeleteFile(APath.c_str());
}
//---------------------------------------------------------------------------
void __fastcall TFiles::Rename(const AnsiString& APath, const AnsiString& AName)
{
	if(!TryRename(APath, AName)) {
		throw EFileError("The program could not rename the file.");
	}
}
//---------------------------------------------------------------------------
bool __fastcall TFiles::TryRename(const AnsiString& APath, const AnsiString& AName)
{
	if(APath.Length() == 0 || AName.Length() == 0 || !TPath(AName).IsValidName()) {
		return false;
	}
	TPath LNewPath = APath;
	LNewPath.Expand();
	LNewPath.Name = AName;
	return ::MoveFile(APath.c_str(), LNewPath.Path.c_str());
}
//---------------------------------------------------------------------------
void __fastcall TFiles::RemoveDirectory(const AnsiString& APath)
{
	if(!TryRemoveDirectory(APath)) {
		throw EFileError("The program could not remove the directory.");
	}
}
//---------------------------------------------------------------------------
bool __fastcall TFiles::TryRemoveDirectory(const AnsiString& APath)
{
	return ::RemoveDirectory(APath.c_str());
}
//---------------------------------------------------------------------------
bool __fastcall TFiles::Exists(const AnsiString& APath) const
{
	DWORD LFileAttributes = ::GetFileAttributes(APath.c_str());
	return LFileAttributes != 0xFFFFFFFF;
}
//---------------------------------------------------------------------------
bool __fastcall TFiles::DriveExists(const AnsiString& APath) const
{
	return ::GetDriveType(APath.c_str()) != 1;
}
//---------------------------------------------------------------------------
bool __fastcall TFiles::DirectoryExists(const AnsiString& APath) const
{
	DWORD LFileAttributes = ::GetFileAttributes(APath.c_str());
	return LFileAttributes != 0xFFFFFFFF && (LFileAttributes & FILE_ATTRIBUTE_DIRECTORY) != 0;
}
//---------------------------------------------------------------------------
bool __fastcall TFiles::RegularFileExists(const AnsiString& APath) const
{
	DWORD LFileAttributes = ::GetFileAttributes(APath.c_str());
	return LFileAttributes != 0xFFFFFFFF && (LFileAttributes & FILE_ATTRIBUTE_DIRECTORY) == 0;
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
AnsiString __fastcall TSystemDirs::GetTempDir() const
{
	TAutoArray<TCHAR> LBuffer = new TCHAR[MAX_PATH];
	UINT LLength = ::GetTempPath(MAX_PATH, LBuffer);
	if(LLength > MAX_PATH || LLength == 0) {
		throw EFileError("The program could not get the path of the directory for temporary files.");
	}
	return AnsiString(LBuffer, LLength);
}
//---------------------------------------------------------------------------
AnsiString __fastcall TSystemDirs::GetSystemDir() const
{
	TAutoArray<TCHAR> LBuffer = new TCHAR[MAX_PATH];
	UINT LLength = ::GetSystemDirectory(LBuffer, MAX_PATH);
	if(LLength > MAX_PATH || LLength == 0) {
		throw EFileError("The program could not get the path of the system directory.");
	}
	return AnsiString(LBuffer, LLength);
}
//---------------------------------------------------------------------------
AnsiString __fastcall TSystemDirs::GetWindowsDir() const
{
	TAutoArray<TCHAR> LBuffer = new TCHAR[MAX_PATH];
	UINT LLength = ::GetWindowsDirectory(LBuffer, MAX_PATH);
	if(LLength > MAX_PATH || LLength == 0) {
		throw EFileError("The program could not get the path of the Windows directory.");
	}
	return AnsiString(LBuffer, LLength);
}
//---------------------------------------------------------------------------
__fastcall TSystemDirs::TSystemDirs()
{
	// Do nothing
}
//---------------------------------------------------------------------------
__fastcall TSystemDirs::~TSystemDirs()
{
	// Do nothing
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
bool __fastcall TFileEnumerator::FindFirst()
{
	State = stBusy;
	::ZeroMemory(&FData, sizeof(WIN32_FIND_DATA));
	HANDLE LHandle = ::FindFirstFile(Path.c_str(), &FData);
	if(LHandle == INVALID_HANDLE_VALUE) {
		Finish();
		return false;
	}
	FHandle = LHandle;
	return true;
}
//---------------------------------------------------------------------------
bool __fastcall TFileEnumerator::FindNext()
{
	::ZeroMemory(&FData, sizeof(WIN32_FIND_DATA));
	if(!::FindNextFile(Handle, &FData)) {
		Finish();
		return false;
	}
	return true;
}
//---------------------------------------------------------------------------
void __fastcall TFileEnumerator::Finish()
{
	if(Handle != NULL) {
		::FindClose(Handle);
		FHandle = NULL;
	}
	State = stOver;
}
//---------------------------------------------------------------------------
void __fastcall TFileEnumerator::SetState(TState AState)
{
	if(AState == State) {
		return;
	}
	FState = AState;
}
//---------------------------------------------------------------------------
WIN32_FIND_DATA __fastcall TFileEnumerator::GetValue()
{
	return Data;
}
//---------------------------------------------------------------------------
__fastcall TFileEnumerator::TFileEnumerator(const AnsiString& APath) :
	TEnumerator<WIN32_FIND_DATA>(),
	FHandle(NULL),
	FPath(APath),
	FData(),
	FState(stNone)
{
	// Do nothing
}
//---------------------------------------------------------------------------
__fastcall TFileEnumerator::~TFileEnumerator()
{
	Finish();
}
//---------------------------------------------------------------------------
bool __fastcall TFileEnumerator::GoToNext()
{
	switch(State) {
	case stNone:
		return FindFirst();
	case stBusy:
		return FindNext();
	default:
		return false;
	}
}
//---------------------------------------------------------------------------
void __fastcall TFileEnumerator::Reset()
{
	Finish();
	State = stNone;
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
int __fastcall TPathList::CompareStrings(const AnsiString S1, const AnsiString S2)
{
	if(CaseSensitive) {
		return Sysutils::AnsiCompareStr(S1, S2);
	}
	else {
		return Sysutils::AnsiCompareFileName(S1, S2);
	}
}
//---------------------------------------------------------------------------
__fastcall TPathList::TPathList() :
	TStringList()
{
	// Do nothing
}
//---------------------------------------------------------------------------
__fastcall TPathList::~TPathList()
{
	// Do nothing
}
//---------------------------------------------------------------------------
} // End namespace Moa_file
//---------------------------------------------------------------------------

