//---------------------------------------------------------------------------
// Version: 1.0.0
// Author: Moochos
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "Moa_List.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
namespace Moa_list {
//---------------------------------------------------------------------------
__fastcall TListHelper::TListHelper(TList* AValue) :
	FValue(AValue)
{
	// Do nothing
}
//---------------------------------------------------------------------------
__fastcall TListHelper::~TListHelper()
{
	// Do nothing
}
//---------------------------------------------------------------------------
void __fastcall TListHelper::AddItems(TList* ASrcList)
{
	EnsureCapacity(Value->Count + ASrcList->Count);
	for(int LI = 0; LI < ASrcList->Count; ++LI) {
		Value->Add(ASrcList->Items[LI]);
	}
	ASrcList->Clear();
}
//---------------------------------------------------------------------------
void __fastcall TListHelper::SwapItems(TList* AList)
{
	TList* LSmallList;
	TList* LLargeList;
	if(Value->Count < AList->Count) {
		LSmallList = Value;
		LLargeList = AList;
	}
	else {
		LSmallList = AList;
		LLargeList = Value;
	}
	TList* LTempList = new TList();
	try {
		LTempList->Assign(LSmallList);
		LSmallList->Assign(LLargeList);
		LLargeList->Assign(LTempList);
	}
	__finally {
		delete LTempList;
	}
}
//---------------------------------------------------------------------------
void* __fastcall TListHelper::PopFirst()
{
	return Pop(0);
}
//---------------------------------------------------------------------------
void* __fastcall TListHelper::PopLast()
{
	return Pop(Value->Count - 1);
}
//---------------------------------------------------------------------------
void* __fastcall TListHelper::Pop(int AIndex)
{
	void* LItem = Value->Items[AIndex];
	Value->Delete(AIndex);
	return LItem;
}
//---------------------------------------------------------------------------
void* __fastcall TListHelper::Swap(int AIndex, void* AItem)
{
	void* LItem = Value->Items[AIndex];
	Value->Items[AIndex] = AItem;
	return LItem;
}
//---------------------------------------------------------------------------
void __fastcall TListHelper::Invert()
{
	for(int LI = 0; LI < Value->Count / 2; ++LI) {
		Value->Exchange(LI, Value->Count - 1 - LI);
	}
}
//---------------------------------------------------------------------------
void __fastcall TListHelper::EnsureCapacity(int ACapacity)
{
	if(Value->Capacity < ACapacity) {
		Value->Capacity = ACapacity;
	}
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
TObjectList* __fastcall TObjectListHelper::GetValue()
{
	return static_cast<TObjectList*>(TListHelper::Value);
}
//---------------------------------------------------------------------------
__fastcall TObjectListHelper::TObjectListHelper(TObjectList* AValue) :
	TListHelper(AValue)
{
	// Do nothing
}
//---------------------------------------------------------------------------
__fastcall TObjectListHelper::~TObjectListHelper()
{
	// Do nothing
}
//---------------------------------------------------------------------------
void __fastcall TObjectListHelper::SwapItems(TObjectList* AList)
{
	bool LOwnsObjects1 = Value->OwnsObjects;
	Value->OwnsObjects = false;
	try {
		bool LOwnsObjects2 = AList->OwnsObjects;
		AList->OwnsObjects = false;
		try {
			TListHelper::SwapItems(AList);
		}
		catch(...) {
			AList->OwnsObjects = LOwnsObjects2;
			throw;
		}
		AList->OwnsObjects = LOwnsObjects2;
	}
	catch(...) {
		Value->OwnsObjects = LOwnsObjects1;
		throw;
	}
	Value->OwnsObjects = LOwnsObjects1;
}
//---------------------------------------------------------------------------
void __fastcall TObjectListHelper::Clear(bool AFreeObjects)
{
	bool LOwnsObjects = Value->OwnsObjects;
	Value->OwnsObjects = AFreeObjects;
	try {
		Value->Clear();
	}
	catch(...) {
		Value->OwnsObjects = LOwnsObjects;
		throw;
	}
	Value->OwnsObjects = LOwnsObjects;
}
//---------------------------------------------------------------------------
TObject* __fastcall TObjectListHelper::PopFirst()
{
	TObject* LFirst;
	bool LOwnsObjects = Value->OwnsObjects;
	Value->OwnsObjects = false;
	try {
		LFirst = static_cast<TObject*>(TListHelper::PopFirst());
	}
	catch(...) {
		Value->OwnsObjects = LOwnsObjects;
		throw;
	}
	Value->OwnsObjects = LOwnsObjects;
	return LFirst;
}
//---------------------------------------------------------------------------
TObject* __fastcall TObjectListHelper::PopLast()
{
	TObject* LLast;
	bool LOwnsObjects = Value->OwnsObjects;
	Value->OwnsObjects = false;
	try {
		LLast = static_cast<TObject*>(TListHelper::PopLast());
	}
	catch(...) {
		Value->OwnsObjects = LOwnsObjects;
		throw;
	}
	Value->OwnsObjects = LOwnsObjects;
	return LLast;
}
//---------------------------------------------------------------------------
TObject* __fastcall TObjectListHelper::Pop(int AIndex)
{
	TObject* LItem;
	bool LOwnsObjects = Value->OwnsObjects;
	Value->OwnsObjects = false;
	try {
		LItem = static_cast<TObject*>(TListHelper::Pop(AIndex));
	}
	catch(...) {
		Value->OwnsObjects = LOwnsObjects;
		throw;
	}
	Value->OwnsObjects = LOwnsObjects;
	return LItem;
}
//---------------------------------------------------------------------------
TObject* __fastcall TObjectListHelper::Swap(int AIndex, TObject* AItem)
{
	TObject* LItem;
	bool LOwnsObjects = Value->OwnsObjects;
	Value->OwnsObjects = false;
	try {
		LItem = static_cast<TObject*>(TListHelper::Swap(AIndex, AItem));
	}
	catch(...) {
		Value->OwnsObjects = LOwnsObjects;
		throw;
	}
	Value->OwnsObjects = LOwnsObjects;
	return LItem;
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
__fastcall TStringsHelper::TStringsHelper(TStrings* AValue) :
	FValue(AValue)
{
	// Do nothing
}
//---------------------------------------------------------------------------
__fastcall TStringsHelper::~TStringsHelper()
{
	// Do nothing
}
//---------------------------------------------------------------------------
void __fastcall TStringsHelper::SwapItems(TStrings* AStrings)
{
	TStrings* LSmallStrings;
	TStrings* LLargeStrings;
	if(Value->Count < AStrings->Count) {
		LSmallStrings = Value;
		LLargeStrings = AStrings;
	}
	else {
		LSmallStrings = AStrings;
		LLargeStrings = Value;
	}
	TStrings* LTempStrings = new TStringList();
	try {
		LTempStrings->Assign(LSmallStrings);
		LSmallStrings->Assign(LLargeStrings);
		LLargeStrings->Assign(LTempStrings);
	}
	__finally {
		delete LTempStrings;
	}
}
//---------------------------------------------------------------------------
AnsiString __fastcall TStringsHelper::PopFirst()
{
	return Pop(0);
}
//---------------------------------------------------------------------------
AnsiString __fastcall TStringsHelper::PopLast()
{
	return Pop(Value->Count - 1);
}
//---------------------------------------------------------------------------
AnsiString __fastcall TStringsHelper::Pop(int AIndex)
{
	AnsiString LString = Value->Strings[AIndex];
	Value->Delete(AIndex);
	return LString;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TStringsHelper::Swap(int AIndex, const AnsiString& AString)
{
	AnsiString LString = Value->Strings[AIndex];
	Value->Strings[AIndex] = AString;
	return LString;
}
//---------------------------------------------------------------------------
TObject* __fastcall TStringsHelper::SwapObject(int AIndex, TObject* AObject)
{
	TObject* LObject = Value->Objects[AIndex];
	Value->Objects[AIndex] = AObject;
	return LObject;
}
//---------------------------------------------------------------------------
void __fastcall TStringsHelper::Invert()
{
	for(int LI = 0; LI < Value->Count / 2; ++LI) {
		Value->Exchange(LI, Value->Count - 1 - LI);
	}
}
//---------------------------------------------------------------------------
int __fastcall TStringsHelper::Find(const AnsiString& AString)
{
	return Value->IndexOf(AString);
}
//---------------------------------------------------------------------------
int __fastcall TStringsHelper::FindObject(TObject* AObject)
{
	for(int LI = 0; LI < Value->Count; ++LI) {
		if(Value->Objects[LI] == AObject) {
			return LI;
		}
	}
	return -1;
}
//---------------------------------------------------------------------------
void __fastcall TStringsHelper::EnsureCapacity(int ACapacity)
{
	if(Value->Capacity < ACapacity) {
		Value->Capacity = ACapacity;
	}
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
TStringList* __fastcall TStringListHelper::GetValue()
{
	return static_cast<TStringList*>(TStringsHelper::Value);
}
//---------------------------------------------------------------------------
__fastcall TStringListHelper::TStringListHelper(TStringList* AValue) :
	TStringsHelper(AValue)
{
	// Do nothing
}
//---------------------------------------------------------------------------
__fastcall TStringListHelper::~TStringListHelper()
{
	// Do nothing
}
//---------------------------------------------------------------------------
bool __fastcall TStringListHelper::TryAdd(const AnsiString& AString)
{
	int LCount = Value->Count;
	Value->Add(AString);
	return Value->Count > LCount;
}
//---------------------------------------------------------------------------
int __fastcall TStringListHelper::Find(const AnsiString& AString)
{
	if(!Value->Sorted) {
		return TStringsHelper::Find(AString);
	}
	int LIndex;
	if(!Value->Find(AString, LIndex)) {
		return -1;
	}
	return LIndex;
}
//---------------------------------------------------------------------------
} // End namespace Moa_list
//---------------------------------------------------------------------------

