//---------------------------------------------------------------------------
#ifndef Moa_RectH
#define Moa_RectH
//---------------------------------------------------------------------------
// Version: 1.0.0
// Author: Moochos
//---------------------------------------------------------------------------
#include <Classes.hpp>
//---------------------------------------------------------------------------
namespace Moa_rect {
//---------------------------------------------------------------------------
class ERectError : public Exception
{
public:
	__fastcall ERectError(const AnsiString& AMessage) : Exception(AMessage) {}
};
//---------------------------------------------------------------------------
class TPointHelper
{
private:
	TPoint FValue;
protected:
	virtual TSmallPoint __fastcall GetAsSmallPoint() const;
	virtual void __fastcall SetAsSmallPoint(const TSmallPoint& ASmallPoint);
	virtual POINT __fastcall GetAsWinPoint() const;
	virtual void __fastcall SetAsWinPoint(const POINT& AWinPoint);
	virtual POINTS __fastcall GetAsWinSmallPoint() const;
	virtual void __fastcall SetAsWinSmallPoint(const POINTS& AWinSmallPoint);
	virtual AnsiString __fastcall GetAsString() const;
	virtual void __fastcall SetAsString(const AnsiString& AString);
public:
	__fastcall TPointHelper();
	__fastcall TPointHelper(const TPoint& AValue);
	__fastcall TPointHelper(const TSmallPoint& AValue);
	__fastcall TPointHelper(const POINT& AWinPoint);
	__fastcall TPointHelper(const POINTS& AWinSmallPoint);
	__fastcall TPointHelper(const TPointHelper& AOther);
	virtual __fastcall ~TPointHelper();
	TPointHelper& __fastcall operator =(const TPointHelper& AOther);
	bool __fastcall operator ==(const TPointHelper& AOther) const;
	bool __fastcall operator !=(const TPointHelper& AOther) const;
	__fastcall operator TPoint() const;
	virtual TPointHelper& __fastcall MoveBy(int AHorzDistance, int AVertDistance);
	__property TPoint Value = {read=FValue, write=FValue};
	__property TSmallPoint AsSmallPoint = {read=GetAsSmallPoint, write=SetAsSmallPoint};
	__property POINT AsWinPoint = {read=GetAsWinPoint, write=SetAsWinPoint};
	__property POINTS AsWinSmallPoint = {read=GetAsWinSmallPoint, write=SetAsWinSmallPoint};
	__property AnsiString AsString = {read=GetAsString, write=SetAsString};
};
//---------------------------------------------------------------------------
class TRectHelper
{
private:
	TRect FValue;
protected:
	virtual RECT __fastcall GetAsWinRect() const;
	virtual void __fastcall SetAsWinRect(const RECT& AWinRect);
	virtual AnsiString __fastcall GetAsString() const;
	virtual void __fastcall SetAsString(const AnsiString& AString);
public:
	__fastcall TRectHelper();
	__fastcall TRectHelper(const TRect& AValue);
	__fastcall TRectHelper(const RECT& AWinRect);
	__fastcall TRectHelper(const TRectHelper& AOther);
	virtual __fastcall ~TRectHelper();
	TRectHelper& __fastcall operator =(const TRectHelper& AOther);
	bool __fastcall operator ==(const TRectHelper& AOther) const;
	bool __fastcall operator !=(const TRectHelper& AOther) const;
	__fastcall operator TRect() const;
	virtual TRectHelper& __fastcall Inflate(int AHorzSize, int AVertSize);
	virtual TRectHelper& __fastcall Intersect(const TRect& ARect);
	virtual TRectHelper& __fastcall MakeEmpty();
	virtual TRectHelper& __fastcall MoveBy(int AHorzDistance, int AVertDistance);
	virtual TRectHelper& __fastcall Subtract(const TRect& ARect);
	virtual TRectHelper& __fastcall Union(const TRect& ARect);
	virtual bool __fastcall Contains(const TPoint& APoint) const;
	virtual bool __fastcall Intersects(const TRect& ARect) const;
	virtual bool __fastcall IsEmpty() const;
	__property TRect Value = {read=FValue, write=FValue};
	__property RECT AsWinRect = {read=GetAsWinRect, write=SetAsWinRect};
	__property AnsiString AsString = {read=GetAsString, write=SetAsString};
};
//---------------------------------------------------------------------------
} // End namespace Moa_rect
using namespace Moa_rect;
//---------------------------------------------------------------------------
#endif

