//---------------------------------------------------------------------------
#ifndef Oren_EditHandlerH
#define Oren_EditHandlerH
//---------------------------------------------------------------------------
// Version: 2.0.0
// Author: Moochos
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include "Oren_Handler.h"
//---------------------------------------------------------------------------
namespace Oren_edithandler {
//---------------------------------------------------------------------------
class TEditHandler : public THandler
{
private:
	static const AnsiString iniAddRegularFilesDialog;
	static const AnsiString iniDereferenceShortcuts;
	static const AnsiString iniFilterIndex;
	TOpenDialog* FAddRegularFilesDialog;
	static bool __fastcall CanHandle(TCommand* ACommand);
	void __fastcall Initialize();
	void __fastcall Uninitialize();
	void __fastcall ChooseAddRegularFiles(TStrings* AFiles);
	AnsiString __fastcall ChooseAddDirectory();
	bool __fastcall GetDereferenceShortcuts();
	void __fastcall SetDereferenceShortcuts(bool ADereferenceShortcuts);
	__property TOpenDialog* AddRegularFilesDialog = {read=FAddRegularFilesDialog};
protected:
public:
	__fastcall TEditHandler(TListViewModel* AControl, TInvoker* AInvoker, TObjectList* AItems);
	virtual __fastcall ~TEditHandler();
	void __fastcall Undo();
	bool __fastcall CanUndo();
	void __fastcall Redo();
	bool __fastcall CanRedo();
	void __fastcall Cut();
	void __fastcall Copy();
	void __fastcall Paste();
	void __fastcall AddDirectory();
	void __fastcall AddRegularFiles();
	void __fastcall Add(TStrings* AFiles);
	void __fastcall Delete();
	void __fastcall SelectAll();
	void __fastcall SelectByType(Oren_rename::TFileType AType);
	void __fastcall SelectByResult(TRenameResult AResult);
	void __fastcall ReverseSelection();
	virtual void __fastcall LoadSettings(TMemIniFile* AFile, TIniSection* ASection);
	virtual void __fastcall SaveSettings(TMemIniFile* AFile, TIniSection* ASection);
	__property bool DereferenceShortcuts = {read=GetDereferenceShortcuts, write=SetDereferenceShortcuts};
};
//---------------------------------------------------------------------------
} // End namespace Oren_edithandler
using namespace Oren_edithandler;
//---------------------------------------------------------------------------
#endif

