//---------------------------------------------------------------------------
// Version: 2.0.0
// Author: Moochos
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "Oren_FreeEditDialog.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TOrenFreeEditDialog* OrenFreeEditDialog = NULL;
//---------------------------------------------------------------------------
void __fastcall TOrenFreeEditDialog::FormCloseQuery(TObject* ASender, bool& ACanClose)
{
	if(ModalResult == mrOk) {
		Values = Inputs;
	}
}
//---------------------------------------------------------------------------
void __fastcall TOrenFreeEditDialog::FormShow(TObject* ASender)
{
	ActiveControl = NULL;
	SelectFirst();
}
//---------------------------------------------------------------------------
void __fastcall TOrenFreeEditDialog::Memo11Change(TObject* ASender)
{
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TOrenFreeEditDialog::Initialize()
{
	try {
		TValues LValues;
		LValues.Text = AnsiString();
		LValues.Count = 0;
		Values = LValues;
	}
	catch(...) {
		Uninitialize();
		throw;
	}
}
//---------------------------------------------------------------------------
void __fastcall TOrenFreeEditDialog::Uninitialize()
{
	// Do nothing
}
//---------------------------------------------------------------------------
void __fastcall TOrenFreeEditDialog::UpdateAccess()
{
	Button91->Enabled = ValidateInputs();
}
//---------------------------------------------------------------------------
bool __fastcall TOrenFreeEditDialog::ValidateInputs()
{
	if(Memo11->Lines->Count != Values.Count) {
		return false;
	}
	return true;
}
//---------------------------------------------------------------------------
TOrenFreeEditDialog::TValues __fastcall TOrenFreeEditDialog::GetInputs()
{
	TValues LInputs = Values;
	LInputs.Text = Memo11->Lines->Text;
	LInputs.Count = Memo11->Lines->Count;
	if(LInputs.Count != Values.Count) {
		throw EInvalidOperation("The number of lines does not match.");
	}
	return LInputs;
}
//---------------------------------------------------------------------------
void __fastcall TOrenFreeEditDialog::SetInputs(const TValues& AInputs)
{
	Memo11->Lines->Clear();
	Memo11->Lines->Text = AInputs.Text;
	Memo11->SelStart = 0;
	Memo11->SelLength = 0;
	::SendMessage(Memo11->Handle, EM_SCROLLCARET, 0, 0);
	if(Memo11->Lines->Count != AInputs.Count) {
		throw EInvalidOperation("The number of lines does not match.");
	}
	UpdateAccess();
}
//---------------------------------------------------------------------------
__fastcall TOrenFreeEditDialog::TOrenFreeEditDialog(TComponent* AOwner) :
	TForm(AOwner),
	FValues()
{
	Initialize();
}
//---------------------------------------------------------------------------
__fastcall TOrenFreeEditDialog::~TOrenFreeEditDialog()
{
	Uninitialize();
}
//---------------------------------------------------------------------------
bool __fastcall TOrenFreeEditDialog::Execute()
{
	Inputs = Values;
	return ShowModal() == mrOk;
}
//---------------------------------------------------------------------------

