//---------------------------------------------------------------------------
#ifndef Oren_HandlerH
#define Oren_HandlerH
//---------------------------------------------------------------------------
// Version: 2.0.0
// Author: Moochos
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <IniFiles.hpp>
#include "Moa_Command.h"
#include "Moa_IniFile.h"
#include "Moa_ListViewModel.h"
#include "Oren_Rename.h"
//---------------------------------------------------------------------------
namespace Oren_handler {
//---------------------------------------------------------------------------
class EHandlerError : public Exception
{
public:
	__fastcall EHandlerError(const AnsiString& AMessage) : Exception(AMessage) {}
};
//---------------------------------------------------------------------------
class THandler : public TObject
{
private:
	TListViewModel* FControl;
	TInvoker* FInvoker;
	TObjectList* FItems;
protected:
	__property TListViewModel* Control = {read=FControl};
	__property TInvoker* Invoker = {read=FInvoker};
	__property TObjectList* Items = {read=FItems};
public:
	__fastcall THandler(TListViewModel* AControl, TInvoker* AInvoker, TObjectList* AItems);
	virtual __fastcall ~THandler();
	virtual void __fastcall LoadSettings(TMemIniFile* AFile, TIniSection* ASection) = 0;
	virtual void __fastcall SaveSettings(TMemIniFile* AFile, TIniSection* ASection) = 0;
};
//---------------------------------------------------------------------------
} // End namespace Oren_handler
using namespace Oren_handler;
//---------------------------------------------------------------------------
#endif

