//---------------------------------------------------------------------------
// Version: 2.1.0
// Author: Moochos
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "Oren_HelpHandler.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
namespace Oren_helphandler {
//---------------------------------------------------------------------------
const AnsiString THelpHandler::HelpFile = ExtractFilePath(Application->ExeName) + "Help\\index.html";
const AnsiString THelpHandler::AboutDesc = "Once Renamer Version 2.1.0\r\n\r\nCopyright (C) 2004-2010 Moochos. All rights reserved.";
//---------------------------------------------------------------------------
__fastcall THelpHandler::THelpHandler(TListViewModel* AControl, TInvoker* AInvoker, TObjectList* AItems) :
	THandler(AControl, AInvoker, AItems)
{
	// Do nothing
}
//---------------------------------------------------------------------------
__fastcall THelpHandler::~THelpHandler()
{
	// Do nothing
}
//---------------------------------------------------------------------------
void __fastcall THelpHandler::ShowContents()
{
	SHELLEXECUTEINFO LInfo = {0};
	LInfo.cbSize = sizeof(SHELLEXECUTEINFO);
	LInfo.fMask = SEE_MASK_FLAG_NO_UI;
	LInfo.hwnd = Application->MainForm->Handle;
	LInfo.lpFile = HelpFile.c_str();
	if(!::ShellExecuteEx(&LInfo)) {
		throw EHandlerError("The program could not open the help.");
	}
}
//---------------------------------------------------------------------------
void __fastcall THelpHandler::ShowAbout()
{
	Application->MessageBox(
		AboutDesc.c_str(),
		"About",
		MB_OK | MB_SETFOREGROUND);
}
//---------------------------------------------------------------------------
void __fastcall THelpHandler::LoadSettings(TMemIniFile* AFile, TIniSection* ASection)
{
	// Do nothing
}
//---------------------------------------------------------------------------
void __fastcall THelpHandler::SaveSettings(TMemIniFile* AFile, TIniSection* ASection)
{
	// Do nothing
}
//---------------------------------------------------------------------------
} // End namespace Oren_helphandler
//---------------------------------------------------------------------------

