//---------------------------------------------------------------------------
#ifndef Oren_ListEditH
#define Oren_ListEditH
//---------------------------------------------------------------------------
// Version: 2.0.0
// Author: Moochos
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include "Moa_ListViewModel.h"
#include "Oren_Rename.h"
//---------------------------------------------------------------------------
namespace Oren_listedit {
//---------------------------------------------------------------------------
class EListEditError : public Exception
{
public:
	__fastcall EListEditError(const AnsiString& AMessage) : Exception(AMessage) {}
};
//---------------------------------------------------------------------------
class TItemUtils
{
private:
protected:
public:
	// Compare
	static int __fastcall ComparePath(const AnsiString& APath1, const AnsiString& APath2);
	static int __fastcall CompareType(Oren_rename::TFileType AType1, Oren_rename::TFileType AType2);
	static int __fastcall CompareResult(TRenameResult AResult1, TRenameResult AResult2);

	// TList::Sort
	static int __fastcall CompareByDirectory(void* AItem1, void* AItem2);
	static int __fastcall CompareByOldName(void* AItem1, void* AItem2);
	static int __fastcall CompareByOldPath(void* AItem1, void* AItem2);
	static int __fastcall CompareByNewName(void* AItem1, void* AItem2);
	static int __fastcall CompareByNewPath(void* AItem1, void* AItem2);
	static int __fastcall CompareByType(void* AItem1, void* AItem2);
	static int __fastcall CompareByResult(void* AItem1, void* AItem2);

	// Describe
	static AnsiString __fastcall DescribePath(const AnsiString& APath);
	static AnsiString __fastcall DescribeType(Oren_rename::TFileType AType);
	static AnsiString __fastcall DescribeResult(TRenameResult AResult);

	// Image index
	static int __fastcall DetermineImageIndex(TRenameItem* AItem);
	static int __fastcall DetermineStateIndex(TRenameItem* AItem);
};
//---------------------------------------------------------------------------
class TRenameList
{
private:
	TListViewModel* FControl;
protected:
public:
	__fastcall TRenameList(TListViewModel* AControl);
	virtual __fastcall ~TRenameList();
	virtual int __fastcall Add(TRenameItem* AItem);
	virtual void __fastcall Insert(int AIndex, TRenameItem* AItem);
	virtual int __fastcall Remove(TRenameItem* AItem);
	virtual void __fastcall Delete(int AIndex);
	__property TListViewModel* Control = {read=FControl};
};
//---------------------------------------------------------------------------
} // End namespace Oren_listedit
using namespace Oren_listedit;
//---------------------------------------------------------------------------
#endif

