//---------------------------------------------------------------------------
#ifndef Oren_ListEditCommandH
#define Oren_ListEditCommandH
//---------------------------------------------------------------------------
// Version: 2.0.0
// Author: Moochos
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include "Oren_EditCommand.h"
//---------------------------------------------------------------------------
namespace Oren_listeditcommand {
//---------------------------------------------------------------------------
class TListEditCommand : public TEditCommand
{
private:
	TListViewModel* FControl;
	TInvoker* FInvoker;
	void __fastcall Initialize();
	void __fastcall Uninitialize();
protected:
	__property TListViewModel* Control = {read=FControl};
public:
	__fastcall TListEditCommand(TListViewModel* AControl);
	virtual __fastcall ~TListEditCommand();
	virtual void __fastcall Execute();
	virtual void __fastcall Undo();
	virtual void __fastcall Redo();
	__property TInvoker* Invoker = {read=FInvoker};
};
//---------------------------------------------------------------------------
class TAddSubCommand : public TCommand
{
private:
	TListViewModel* FControl;
	TRenameItem* FItem;
protected:
	__property TListViewModel* Control = {read=FControl};
	__property TRenameItem* Item = {read=FItem};
public:
	__fastcall TAddSubCommand(TListViewModel* AControl, TRenameItem* AItem);
	virtual __fastcall ~TAddSubCommand();
	virtual void __fastcall Execute();
	virtual void __fastcall Undo();
	virtual void __fastcall Redo();
};
//---------------------------------------------------------------------------
class TDeleteSubCommand : public TCommand
{
private:
	TListViewModel* FControl;
	int FIndex;
	TRenameItem* FItem;
protected:
	__property TListViewModel* Control = {read=FControl};
	__property int Index = {read=FIndex};
	__property TRenameItem* Item = {read=FItem};
public:
	__fastcall TDeleteSubCommand(TListViewModel* AControl, int AIndex);
	virtual __fastcall ~TDeleteSubCommand();
	virtual void __fastcall Execute();
	virtual void __fastcall Undo();
	virtual void __fastcall Redo();
};
//---------------------------------------------------------------------------
} // End namespace Oren_listeditcommand
using namespace Oren_listeditcommand;
//---------------------------------------------------------------------------
#endif

