//---------------------------------------------------------------------------
// Version: 2.0.0
// Author: Moochos
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "Oren_NumbersDialog.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TOrenNumbersDialog* OrenNumbersDialog = NULL;
//---------------------------------------------------------------------------
void __fastcall TOrenNumbersDialog::FormCloseQuery(TObject* ASender, bool& ACanClose)
{
	if(ModalResult == mrOk) {
		Values = Inputs;
	}
}
//---------------------------------------------------------------------------
void __fastcall TOrenNumbersDialog::FormShow(TObject* ASender)
{
	ActiveControl = NULL;
	SelectFirst();
}
//---------------------------------------------------------------------------
void __fastcall TOrenNumbersDialog::Edit13Change(TObject* ASender)
{
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TOrenNumbersDialog::Edit14Change(TObject* ASender)
{
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TOrenNumbersDialog::Edit15Change(TObject* ASender)
{
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TOrenNumbersDialog::Edit16Change(TObject* ASender)
{
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TOrenNumbersDialog::Initialize()
{
	try {
		TValues LValues;
		LValues.Prefix = AnsiString();
		LValues.Suffix = AnsiString();
		LValues.Initial = 1;
		LValues.Increment = 1;
		LValues.Digits = 1;
		LValues.Padding = '0';
		Values = LValues;
	}
	catch(...) {
		Uninitialize();
		throw;
	}
}
//---------------------------------------------------------------------------
void __fastcall TOrenNumbersDialog::Uninitialize()
{
	// Do nothing
}
//---------------------------------------------------------------------------
void __fastcall TOrenNumbersDialog::UpdateAccess()
{
	Button91->Enabled = ValidateInput();
}
//---------------------------------------------------------------------------
bool __fastcall TOrenNumbersDialog::ValidateInput()
{
	try {
		StrToInt(Edit13->Text);
		StrToInt(Edit14->Text);
		if(StrToInt(Edit15->Text) < 0) {
			return false;
		}
		if(Edit16->Text.Length() != 1) {
			return false;
		}
	}
	catch(EConvertError& LException) {
		return false;
	}
	return true;
}
//---------------------------------------------------------------------------
TOrenNumbersDialog::TValues __fastcall TOrenNumbersDialog::GetInputs()
{
	TValues LInputs;
	LInputs.Prefix = Edit11->Text;
	LInputs.Suffix = Edit12->Text;
	LInputs.Initial = StrToInt(Edit13->Text);
	LInputs.Increment = StrToInt(Edit14->Text);
	LInputs.Digits = StrToInt(Edit15->Text);
	LInputs.Padding = (Edit16->Text)[1];
	return LInputs;
}
//---------------------------------------------------------------------------
void __fastcall TOrenNumbersDialog::SetTInputs(const TValues& AInputs)
{
	Edit11->Text = AInputs.Prefix;
	Edit12->Text = AInputs.Suffix;
	Edit13->Text = AInputs.Initial;
	Edit14->Text = AInputs.Increment;
	Edit15->Text = AInputs.Digits;
	Edit16->Text = AInputs.Padding;
	UpdateAccess();
}
//---------------------------------------------------------------------------
__fastcall TOrenNumbersDialog::TOrenNumbersDialog(TComponent* AOwner) :
	TForm(AOwner),
	FValues()
{
	Initialize();
}
//---------------------------------------------------------------------------
__fastcall TOrenNumbersDialog::~TOrenNumbersDialog()
{
	Uninitialize();
}
//---------------------------------------------------------------------------
bool __fastcall TOrenNumbersDialog::Execute()
{
	Inputs = Values;
	return ShowModal() == mrOk;
}
//---------------------------------------------------------------------------

