//---------------------------------------------------------------------------
// Version: 2.1.0
// Author: Moochos
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "Oren_NumbersDialog.h"
#include "Oren_OverwriteDialog.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TOrenOverwriteDialog* OrenOverwriteDialog = NULL;
//---------------------------------------------------------------------------
void __fastcall TOrenOverwriteDialog::FormCloseQuery(TObject* ASender, bool& ACanClose)
{
	if(ModalResult == mrOk) {
		Values = Inputs;
	}
}
//---------------------------------------------------------------------------
void __fastcall TOrenOverwriteDialog::FormShow(TObject* ASender)
{
	ActiveControl = NULL;
	SelectFirst();
}
//---------------------------------------------------------------------------
void __fastcall TOrenOverwriteDialog::Button11Click(TObject* ASender)
{
	OrenNumbersDialog->Execute();
}
//---------------------------------------------------------------------------
void __fastcall TOrenOverwriteDialog::ComboBox11Click(TObject* ASender)
{
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TOrenOverwriteDialog::Edit11Change(TObject* ASender)
{
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TOrenOverwriteDialog::RadioButton11Click(TObject* ASender)
{
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TOrenOverwriteDialog::RadioButton12Click(TObject* ASender)
{
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TOrenOverwriteDialog::RadioButton13Click(TObject* ASender)
{
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TOrenOverwriteDialog::Initialize()
{
	try {
		if(OrenNumbersDialog == NULL) {
			OrenNumbersDialog = new TOrenNumbersDialog(Application);
		}
		TValues LValues;
		LValues.Part = npBaseName;
		LValues.Text.Kind = slCustom;
		LValues.Text.Set.Custom.Text = AnsiString();
		LValues.Text.Set.Number = OrenNumbersDialog->Values;
		Values = LValues;
	}
	catch(...) {
		Uninitialize();
		throw;
	}
}
//---------------------------------------------------------------------------
void __fastcall TOrenOverwriteDialog::Uninitialize()
{
	// Do nothing
}
//---------------------------------------------------------------------------
void __fastcall TOrenOverwriteDialog::UpdateAccess()
{
	Edit11->Enabled = RadioButton11->Checked;
	Button11->Enabled = RadioButton12->Checked;
	Button91->Enabled = ValidateInputs();
}
//---------------------------------------------------------------------------
bool __fastcall TOrenOverwriteDialog::ValidateInputs()
{
	if(RadioButton11->Checked && Edit11->Text.Length() == 0) {
		return false;
	}
	if(ComboBox11->ItemIndex < 0) {
		return false;
	}
	return true;
}
//---------------------------------------------------------------------------
TOrenOverwriteDialog::TValues __fastcall TOrenOverwriteDialog::GetInputs()
{
	TValues LInputs;
	switch(ComboBox11->ItemIndex) {
	case 0: LInputs.Part = npName; break;
	case 1: LInputs.Part = npBaseName; break;
	case 2: LInputs.Part = npExtension; break;
	default: throw EInvalidOperation("The part is not specified.");
	}
	if(RadioButton11->Checked) {
		LInputs.Text.Kind = slCustom;
	}
	else if(RadioButton12->Checked) {
		LInputs.Text.Kind = slNumber;
	}
	else if(RadioButton13->Checked) {
		LInputs.Text.Kind = slClipboard;
	}
	else {
		throw EInvalidOperation("The kind is not specified.");
	}
	LInputs.Text.Set.Custom.Text = Edit11->Text;
	LInputs.Text.Set.Number = OrenNumbersDialog->Values;
	return LInputs;
}
//---------------------------------------------------------------------------
void __fastcall TOrenOverwriteDialog::SetInputs(const TValues& AInputs)
{
	switch(AInputs.Part) {
	case npName: ComboBox11->ItemIndex = 0; break;
	case npBaseName: ComboBox11->ItemIndex = 1; break;
	case npExtension: ComboBox11->ItemIndex = 2; break;
	default: ComboBox11->ItemIndex = -1; break;
	}
	RadioButton11->Checked = AInputs.Text.Kind == slCustom;
	RadioButton12->Checked = AInputs.Text.Kind == slNumber;
	RadioButton13->Checked = AInputs.Text.Kind == slClipboard;
	Edit11->Text = AInputs.Text.Set.Custom.Text;
	OrenNumbersDialog->Values = AInputs.Text.Set.Number;
	UpdateAccess();
}
//---------------------------------------------------------------------------
__fastcall TOrenOverwriteDialog::TOrenOverwriteDialog(TComponent* AOwner) :
	TForm(AOwner),
	FValues()
{
	Initialize();
}
//---------------------------------------------------------------------------
__fastcall TOrenOverwriteDialog::~TOrenOverwriteDialog()
{
	Uninitialize();
}
//---------------------------------------------------------------------------
bool __fastcall TOrenOverwriteDialog::Execute()
{
	Inputs = Values;
	return ShowModal() == mrOk;
}
//---------------------------------------------------------------------------

