//---------------------------------------------------------------------------
// Version: 2.0.0
// Author: Moochos
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "Moa_AutoPointer.h"
#include "Moa_File.h"
#include "Oren_Rename.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
namespace Oren_rename {
//---------------------------------------------------------------------------
TFileType __fastcall TRenameItem::DetermineType(const AnsiString& APath)
{
	try {
		if((TFile(APath).Attributes & FILE_ATTRIBUTE_DIRECTORY) != 0) {
			return Oren_rename::ftDirectory;
		}
		else {
			return Oren_rename::ftRegularFile;
		}
	}
	catch(EFileError& LException) {
		throw ERenameError("The program cannot determine the file type.");
	}
}
//---------------------------------------------------------------------------
AnsiString __fastcall TRenameItem::GetOldPath()
{
	return TPath(Directory).Push(OldName);
}
//---------------------------------------------------------------------------
AnsiString __fastcall TRenameItem::GetNewPath()
{
	return TPath(Directory).Push(NewName);
}
//---------------------------------------------------------------------------
__fastcall TRenameItem::TRenameItem(const AnsiString& APath) :
	TObject(),
	FDirectory(),
	FOldName(),
	FNewName(),
	FType(Oren_rename::ftRegularFile),
	FResult(reNone)
{
	TPath LPath(APath);
	FDirectory = LPath.Directory;
	FOldName = LPath.Name;
	FNewName = LPath.Name;
	FType = DetermineType(APath);
}
//---------------------------------------------------------------------------
__fastcall TRenameItem::~TRenameItem()
{
	// Do nothing
}
//---------------------------------------------------------------------------
void __fastcall TRenameItem::Assign(TRenameItem* AOther)
{
	if(AOther == this) {
		return;
	}
	FDirectory = AOther->FDirectory;
	FOldName = AOther->FOldName;
	FNewName = AOther->FNewName;
	FType = AOther->FType;
	FResult = AOther->FResult;
}
//---------------------------------------------------------------------------
void __fastcall TRenameItem::Update()
{
	TAutoPointer<TRenameItem> LInstance = new TRenameItem(OldPath);
	Assign(LInstance);
}
//---------------------------------------------------------------------------
} // End namespace Oren_rename
//---------------------------------------------------------------------------

