//---------------------------------------------------------------------------
#ifndef Oren_RenameH
#define Oren_RenameH
//---------------------------------------------------------------------------
// Version: 2.0.0
// Author: Moochos
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include "Moa_Command.h"
//---------------------------------------------------------------------------
namespace Oren_rename {
//---------------------------------------------------------------------------
class ERenameError : public Exception
{
public:
	__fastcall ERenameError(const AnsiString& AMessage) : Exception(AMessage) {}
};
//---------------------------------------------------------------------------
enum TFileType
{
	ftDirectory,
	ftRegularFile,
};
//---------------------------------------------------------------------------
enum TRenameResult
{
	reNone,
	reSucceeded,
	reFailed,
	reSkipped,
};
//---------------------------------------------------------------------------
class TRenameItem : public TObject
{
private:
	AnsiString FDirectory;
	AnsiString FOldName;
	AnsiString FNewName;
	TFileType FType;
	TRenameResult FResult;
	static TFileType __fastcall DetermineType(const AnsiString& APath);
	AnsiString __fastcall GetOldPath();
	AnsiString __fastcall GetNewPath();
protected:
public:
	__fastcall TRenameItem(const AnsiString& APath);
	virtual __fastcall ~TRenameItem();
	virtual void __fastcall Assign(TRenameItem* AOther);
	virtual void __fastcall Update();
	__property AnsiString Directory = {read=FDirectory};
	__property AnsiString OldName = {read=FOldName, write=FOldName};
	__property AnsiString OldPath = {read=GetOldPath};
	__property AnsiString NewName = {read=FNewName, write=FNewName};
	__property AnsiString NewPath = {read=GetNewPath};
	__property TFileType Type = {read=FType};
	__property TRenameResult Result = {read=FResult, write=FResult};
};
//---------------------------------------------------------------------------
} // End namespace Oren_rename
using namespace Oren_rename;
//---------------------------------------------------------------------------
#endif

