//---------------------------------------------------------------------------
// Version: 2.0.0
// Author: Moochos
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "Oren_RenameCommand.h"
#include "Oren_RenameHandler.h"
#include "Oren_ResultsDialog.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
namespace Oren_renamehandler {
//---------------------------------------------------------------------------
bool __fastcall TRenameHandler::CanHandle(TCommand* ACommand)
{
	return ACommand->InheritsFrom(__classid(TRenameCommand));
}
//---------------------------------------------------------------------------
__fastcall TRenameHandler::TRenameHandler(TListViewModel* AControl, TInvoker* AInvoker, TObjectList* AItems) :
	THandler(AControl, AInvoker, AItems),
	FBusy(false)
{
	// Do nothing
}
//---------------------------------------------------------------------------
__fastcall TRenameHandler::~TRenameHandler()
{
	// Do nothing
}
//---------------------------------------------------------------------------
void __fastcall TRenameHandler::Perform()
{
	Busy = true;
	try {
		Invoker->Commands->Add(new TRenameCommand(Control));
		Invoker->Execute();
	}
	__finally {
		Busy = false;
	}
}
//---------------------------------------------------------------------------
void __fastcall TRenameHandler::Undo(bool AConfirm)
{
	if(!CanUndo()) {
		throw ERenameError("The program cannot undo the rename task.");
	}
	Busy = true;
	try {
		Invoker->Undo();
	}
	__finally {
		Busy = false;
	}
}
//---------------------------------------------------------------------------
bool __fastcall TRenameHandler::CanUndo()
{
	return Invoker->CanUndo() && CanHandle(Invoker->NextUndoCommand);
}
//---------------------------------------------------------------------------
void __fastcall TRenameHandler::Redo(bool AConfirm)
{
	if(!CanRedo()) {
		throw ERenameError("The program cannot redo the rename task.");
	}
	Busy = true;
	try {
		Invoker->Redo();
	}
	__finally {
		Busy = false;
	}
}
//---------------------------------------------------------------------------
bool __fastcall TRenameHandler::CanRedo()
{
	return Invoker->CanRedo() && CanHandle(Invoker->NextRedoCommand);
}
//---------------------------------------------------------------------------
bool __fastcall TRenameHandler::IsBusy()
{
	return Busy;
}
//---------------------------------------------------------------------------
void __fastcall TRenameHandler::ShowResults()
{
	if(OrenResultsDialog == NULL) {
		OrenResultsDialog = new TOrenResultsDialog(Application);
	}
	OrenResultsDialog->Counter->Reset();
	for(int LI = 0; LI < Control->Count; ++LI) {
		OrenResultsDialog->Counter->Increment(static_cast<TRenameItem*>(Control->Items[LI]->Value)->Result);
	}
	OrenResultsDialog->Execute();
}
//---------------------------------------------------------------------------
void __fastcall TRenameHandler::LoadSettings(TMemIniFile* AFile, TIniSection* ASection)
{
	// Do nothing
}
//---------------------------------------------------------------------------
void __fastcall TRenameHandler::SaveSettings(TMemIniFile* AFile, TIniSection* ASection)
{
	// Do nothing
}
//---------------------------------------------------------------------------
} // End namespace Oren_renamehandler
//---------------------------------------------------------------------------

