//---------------------------------------------------------------------------
// Version: 2.0.0
// Author: Moochos
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "Oren_RenameCommand.h"
#include "Oren_RenameTask.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
namespace Oren_renametask {
//---------------------------------------------------------------------------
void __fastcall TRenameTask::ResetResults()
{
	for(int LI = 0; LI < Control->Count; ++LI) {
		static_cast<TRenameItem*>(Control->Items[LI]->Value)->Result = reNone;
	}
}
//---------------------------------------------------------------------------
void __fastcall TRenameTask::ExecuteCommands()
{
	int LCurrent = 0;
	int LAll = Invoker->Commands->Count + Invoker->UndoCommands->Count + Invoker->RedoCommands->Count;
	while(LCurrent < LAll) {
		if(Cancelled) {
			Abort();
		}
		ExecuteNext();
		Progress = static_cast<__int64>(++LCurrent) * 100 / LAll;
	}
	Progress = 100;
}
//---------------------------------------------------------------------------
void __fastcall TRenameTask::DoProgress(int AProgress)
{
	if(OnProgress != NULL) {
		Synchronize(DoProgressInMainThread, &AProgress);
	}
}
//---------------------------------------------------------------------------
void __fastcall TRenameTask::DoProgressInMainThread(void* AData)
{
	if(OnProgress != NULL) {
		OnProgress(this, *static_cast<int*>(AData));
	}
}
//---------------------------------------------------------------------------
void __fastcall TRenameTask::SetProgress(int AProgress)
{
	if(AProgress == Progress) {
		return;
	}
	FProgress = AProgress;
	DoProgress(Progress);
}
//---------------------------------------------------------------------------
void __fastcall TRenameTask::Execute()
{
	ResetResults();
	ExecuteCommands();
}
//---------------------------------------------------------------------------
__fastcall TRenameTask::TRenameTask(TListViewModel* AControl, TInvoker* AInvoker) :
	TTask(),
	FControl(AControl),
	FInvoker(AInvoker),
	FProgress(0),
	FOnProgress(NULL)
{
	// Do nothing
}
//---------------------------------------------------------------------------
__fastcall TRenameTask::~TRenameTask()
{
	// Do nothing
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
void __fastcall TDoRenameTask::AddCommands()
{
	Invoker->Commands->Capacity = Control->Count;
	for(int LI = 0; LI < Control->Count; ++LI) {
		if(Cancelled) {
			Abort();
		}
		Invoker->Commands->Add(new TRenameSubCommand(static_cast<TRenameItem*>(Control->Items[LI]->Value)));
	}
}
//---------------------------------------------------------------------------
void __fastcall TDoRenameTask::Execute()
{
	try {
		AddCommands();
		TRenameTask::Execute();
	}
	catch(...) {
		Invoker->Commands->Clear();
		throw;
	}
}
//---------------------------------------------------------------------------
void __fastcall TDoRenameTask::ExecuteNext()
{
	Invoker->Execute();
}
//---------------------------------------------------------------------------
__fastcall TDoRenameTask::TDoRenameTask(TListViewModel* AControl, TInvoker* AInvoker) :
	TRenameTask(AControl, AInvoker)
{
	// Do nothing
}
//---------------------------------------------------------------------------
__fastcall TDoRenameTask::~TDoRenameTask()
{
	// Do nothing
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
void __fastcall TUndoRenameTask::Execute()
{
	try {
		TRenameTask::Execute();
	}
	catch(...) {
		Invoker->UndoCommands->Clear();
		throw;
	}
}
//---------------------------------------------------------------------------
void __fastcall TUndoRenameTask::ExecuteNext()
{
	Invoker->Undo();
}
//---------------------------------------------------------------------------
__fastcall TUndoRenameTask::TUndoRenameTask(TListViewModel* AControl, TInvoker* AInvoker) :
	TRenameTask(AControl, AInvoker)
{
	// Do nothing
}
//---------------------------------------------------------------------------
__fastcall TUndoRenameTask::~TUndoRenameTask()
{
	// Do nothing
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
void __fastcall TRedoRenameTask::Execute()
{
	try {
		TRenameTask::Execute();
	}
	catch(...) {
		Invoker->RedoCommands->Clear();
		throw;
	}
}
//---------------------------------------------------------------------------
void __fastcall TRedoRenameTask::ExecuteNext()
{
	Invoker->Redo();
}
//---------------------------------------------------------------------------
__fastcall TRedoRenameTask::TRedoRenameTask(TListViewModel* AControl, TInvoker* AInvoker) :
	TRenameTask(AControl, AInvoker)
{
	// Do nothing
}
//---------------------------------------------------------------------------
__fastcall TRedoRenameTask::~TRedoRenameTask()
{
	// Do nothing
}
//---------------------------------------------------------------------------
} // End namespace Oncerenamer_rename_task
//---------------------------------------------------------------------------

